

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Getting started &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
        <script src="../../_static/jquery.js"></script>
        <script src="../../_static/underscore.js"></script>
        <script src="../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script src="../../_static/js/bootstrap.min.js"></script>
        <script src="../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Time" href="getting_started/time.html" />
    <link rel="prev" title="DTSS - Distributed Time Series System" href="concepts/dts.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="concepts.html">Concepts</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Getting started</a><ul>
<li class="toctree-l2"><a class="reference internal" href="getting_started/time.html">Time</a></li>
<li class="toctree-l2"><a class="reference internal" href="getting_started/calendar.html">Calendar</a></li>
<li class="toctree-l2"><a class="reference internal" href="getting_started/time_axis.html">TimeAxis</a></li>
<li class="toctree-l2"><a class="reference internal" href="getting_started/time_series.html">TimeSeries</a></li>
<li class="toctree-l2"><a class="reference internal" href="getting_started/dts.html">Distributed Time Series (DTS)</a></li>
<li class="toctree-l2"><a class="reference internal" href="getting_started/notebooks.html">Examples</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../hydrology/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
      <li>Getting started</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/content/time_series/getting_started.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="getting-started">
<h1>Getting started<a class="headerlink" href="#getting-started" title="Permalink to this headline">¶</a></h1>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This Python package is a wrapper around a C++ library. In contrast to Python, C++ allows
<a class="reference external" href="https://en.wikipedia.org/wiki/Function_overloading">function overloading</a> which leads
to some confusion in some <a class="reference external" href="https://en.wikipedia.org/wiki/Integrated_development_environment">IDEs</a>
like <a class="reference external" href="https://www.jetbrains.com/pycharm/">PyCharm</a> and to doc strings unfamiliar to pure
Python developers i.e. full C++ call signatures.</p>
<p>The code in this package is designed to make use of standard help functionality in Python.
You are able to access help functionality using tab completion or <cite>help()</cite>. The “?” or “??”
standards in IPython work, but seem at times to be limited with respect to some of the
doc strings. Therefore, we encourage you to please use <cite>help</cite>.</p>
<p>If you use <cite>help(shyft_object)</cite> and get something that is looks a bit overwhelming or unfamiliar,
just realize that the methods are generally showing how to call a method and what it returns.
If you see <cite>(object)arg1</cite> or <cite>(object)self</cite> as a first argument to a method, that simply means
<a class="reference external" href="https://www.programiz.com/article/python-self-why">the class itself is the first argument</a>.</p>
<p>Example:</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>$ python
Python <span class="m">3</span>.8.8 <span class="o">(</span>default, Feb <span class="m">24</span> <span class="m">2021</span>, <span class="m">15</span>:54:32<span class="o">)</span> <span class="o">[</span>...<span class="o">]</span>
Type <span class="s2">&quot;help&quot;</span>, <span class="s2">&quot;copyright&quot;</span>, <span class="s2">&quot;credits&quot;</span> or <span class="s2">&quot;license&quot;</span> <span class="k">for</span> more information.
&gt;&gt;&gt;import shyft.time_series
&gt;&gt;&gt;help<span class="o">(</span>shyft.time_series.Calendar<span class="o">)</span>

<span class="o">[</span>...<span class="o">]</span>

<span class="p">|</span>  Static methods defined here:
<span class="p">|</span>
<span class="p">|</span>  __init__<span class="o">(</span>...<span class="o">)</span>
<span class="p">|</span>      __init__<span class="o">(</span> <span class="o">(</span>Calendar<span class="o">)</span>arg1<span class="o">)</span> -&gt; None
<span class="p">|</span>
<span class="p">|</span>      __init__<span class="o">(</span> <span class="o">(</span>Calendar<span class="o">)</span>arg1, <span class="o">(</span><span class="nb">time</span><span class="o">)</span>tz_offset<span class="o">)</span> -&gt; None :
<span class="p">|</span>          creates a calendar with constant tz-offset
<span class="p">|</span>
<span class="p">|</span>          Args:
<span class="p">|</span>              tz_offset <span class="o">(</span><span class="nb">time</span><span class="o">)</span>: specifies utc offset, time<span class="o">(</span><span class="m">3600</span><span class="o">)</span> gives UTC+01 zone
<span class="p">|</span>
<span class="p">|</span>
<span class="p">|</span>      __init__<span class="o">(</span> <span class="o">(</span>Calendar<span class="o">)</span>arg1, <span class="o">(</span>int<span class="o">)</span>tz_offset<span class="o">)</span> -&gt; None :
<span class="p">|</span>          creates a calendar with constant tz-offset
<span class="p">|</span>
<span class="p">|</span>          Args:
<span class="p">|</span>              tz_offset <span class="o">(</span>int<span class="o">)</span>: seconds utc offset, <span class="m">3600</span> gives UTC+01 zone
<span class="p">|</span>
<span class="p">|</span>
<span class="p">|</span>      __init__<span class="o">(</span> <span class="o">(</span>Calendar<span class="o">)</span>arg1, <span class="o">(</span>str<span class="o">)</span>olson_tz_id<span class="o">)</span> -&gt; None :
<span class="p">|</span>          create a Calendar from Olson timezone id, eg. <span class="s1">&#39;Europe/Oslo&#39;</span>
<span class="p">|</span>
<span class="p">|</span>          Args:
<span class="p">|</span>              olson_tz_id <span class="o">(</span>str<span class="o">)</span>: Olson time-zone id, e.g. <span class="s1">&#39;Europe/Oslo&#39;</span>
<span class="o">[</span>...<span class="o">]</span>
</pre></div>
</div>
<p>What this means is that the <em>class</em> <code class="docutils literal notranslate"><span class="pre">Calendar</span></code> may be instantiated as either:</p>
<ol class="arabic simple">
<li><p><code class="docutils literal notranslate"><span class="pre">Calendar()</span></code>, returning an UTC Calendar</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Calendar(200)</span></code>, indicating a fixed offset of 200 seconds from UTC</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Calendar('Europe/Oslo')</span></code> where the calendar will be ‘tied’ to the “Europe/Oslo” timezone.</p></li>
</ol>
</div>
<p>This section contains practical examples of how to use the types and functions provided
in this package.</p>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="getting_started/time.html">Time</a><ul>
<li class="toctree-l2"><a class="reference internal" href="getting_started/time.html#create-a-time-object">Create a time object</a></li>
<li class="toctree-l2"><a class="reference internal" href="getting_started/time.html#using-a-time-object">Using a time object</a></li>
<li class="toctree-l2"><a class="reference internal" href="getting_started/time.html#containers">Containers</a><ul>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time.html#utcperiod">UtcPeriod</a></li>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time.html#ymdhms">YMDhms</a></li>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time.html#ywdhms">YWdhms</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="getting_started/calendar.html">Calendar</a><ul>
<li class="toctree-l2"><a class="reference internal" href="getting_started/calendar.html#create-a-calendar-object">Create a Calendar object</a></li>
<li class="toctree-l2"><a class="reference internal" href="getting_started/calendar.html#calendar-and-time">Calendar and time</a></li>
<li class="toctree-l2"><a class="reference internal" href="getting_started/calendar.html#python-datetime-to-shyft-time">Python datetime to Shyft time</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="getting_started/time_axis.html">TimeAxis</a><ul>
<li class="toctree-l2"><a class="reference internal" href="getting_started/time_axis.html#create-a-timeaxis-object">Create a TimeAxis object</a><ul>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time_axis.html#fixed-interval-time-axis">Fixed interval time axis</a></li>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time_axis.html#ireggular-interval-time-axis">Ireggular interval time axis</a></li>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time_axis.html#calendar-time-axis">Calendar time axis</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="getting_started/time_axis.html#a-few-helpful-functions">A few helpful functions</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="getting_started/time_series.html">TimeSeries</a><ul>
<li class="toctree-l2"><a class="reference internal" href="getting_started/time_series.html#time-series-types">Time series types</a><ul>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time_series.html#point-instant-value"><code class="docutils literal notranslate"><span class="pre">POINT_INSTANT_VALUE</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time_series.html#point-average-value"><code class="docutils literal notranslate"><span class="pre">POINT_AVERAGE_VALUE</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="getting_started/time_series.html#inspection-functions">Inspection functions</a><ul>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time_series.html#timeseries-t-int-float-time">TimeSeries(t: int/float/time)</a></li>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time_series.html#point-interpretation">point_interpretation()</a></li>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time_series.html#size">size()</a></li>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time_series.html#time-axis">time_axis</a></li>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time_series.html#values-to-numpy">values.to_numpy()</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="getting_started/time_series.html#general-time-series-manipulation">General time series manipulation</a><ul>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time_series.html#arithmetics">Arithmetics</a></li>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time_series.html#mathematical-operations">Mathematical operations</a><ul>
<li class="toctree-l4"><a class="reference internal" href="getting_started/time_series.html#average">Average</a></li>
<li class="toctree-l4"><a class="reference internal" href="getting_started/time_series.html#accumulate">Accumulate</a></li>
<li class="toctree-l4"><a class="reference internal" href="getting_started/time_series.html#derivative">Derivative</a></li>
<li class="toctree-l4"><a class="reference internal" href="getting_started/time_series.html#integral">Integral</a></li>
<li class="toctree-l4"><a class="reference internal" href="getting_started/time_series.html#statistics">Statistics</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="getting_started/time_series.html#utility-functions">Utility functions</a><ul>
<li class="toctree-l4"><a class="reference internal" href="getting_started/time_series.html#inside">Inside</a></li>
<li class="toctree-l4"><a class="reference internal" href="getting_started/time_series.html#max-min">Max/min</a></li>
<li class="toctree-l4"><a class="reference internal" href="getting_started/time_series.html#time-shift">Time shift</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="getting_started/dts.html">Distributed Time Series (DTS)</a><ul>
<li class="toctree-l2"><a class="reference internal" href="getting_started/dts.html#dtsserver">DtsServer</a></li>
<li class="toctree-l2"><a class="reference internal" href="getting_started/dts.html#dtsclient">DtsClient</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="getting_started/notebooks.html">Examples</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../notebooks/time_series/convolve.html">ts.convolve_w</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/time_series/convolve.html#ts.convolve_w(weights,-convolve_policy)-function">ts.convolve_w(weights, convolve_policy) function</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../notebooks/time_series/decode.html">ts.decode</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/time_series/decode.html#ts.decode(start_bit=n,-n_bits=nb)">ts.decode(start_bit=n, n_bits=nb)</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../notebooks/time_series/derivative.html">ts.derivative</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/time_series/derivative.html#ts.derivative()">ts.derivative()</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../notebooks/time_series/inside.html">ts.inside</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/time_series/inside.html#ts.inside(min_v,-max_v,-nan_v,-inside_v,-outside_v)">ts.inside(min_v, max_v, nan_v, inside_v, outside_v)</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../notebooks/time_series/partition_by_and_percentiles.html">ts.partition_by and ts.percentiles</a></li>
<li class="toctree-l2"><a class="reference internal" href="../../notebooks/time_series/dtss-krls-container.html">KRLS predictor using DTSS containers</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/time_series/dtss-krls-container.html#Introduction">Introduction</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/time_series/dtss-krls-container.html#0.-Setup-the-demo">0. Setup the demo</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/time_series/dtss-krls-container.html#1.-Register-a-KRLS-time-series">1. Register a KRLS time-series</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/time_series/dtss-krls-container.html#2.-Predict-a-time-series">2. Predict a time-series</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/time_series/dtss-krls-container.html#3.-Update-the-trained-period">3. Update the trained period</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../notebooks/time_series/dtss-krls-container.html#4.-Repredict">4. Repredict</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="getting_started/time.html" class="btn btn-neutral float-right" title="Time" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="concepts/dts.html" class="btn btn-neutral float-left" title="DTSS - Distributed Time Series System" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>